<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des comptes validés ou débloqués</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">
          Nombre total de comptes activés/débloqués : {{ total }}
        </h3>
      </div>
      <mt-list v-slot="{ item: user }" :list="users">
        <mt-list-item>
          <div class="columns is-vcentered">
            <div class="column">
              <span>&nbsp;{{ user.nom }}</span>
            </div>
            <div class="column">
              {{ user.prenom }}
            </div>
            <div class="column">
              {{ user.email }}
            </div>
            <div class="column">
              {{ dateFormat(user.dateActif) }}
            </div>
            <div class="column is-narrow">
              <a
                :href="
                  `mailto:${user.email}?subject=[METIIS] Votre compte a été activé.&body=Bonjour ${user.nom} ${user.prenom}.%0D%0A%0D%0AVotre compte METIIS est actif, vous pouvez maintenant vous connecter à l'application.%0D%0A%0D%0A`
                "
                class="mailto"
              >
                Envoyer un mail de confirmation
              </a>
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Comptes suivants"
        aria-previous-label="Comptes précedents"
        aria-page-label="Comptes"
        aria-current-label="Page courante"
      />
    </div>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const {
      content: users,
      totalElements: total,
      numberOfElements: nombrePageCourante,
    } = await $api.users.comptesActifs(pageCourante - 1, parPage);
    return {
      users,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
    };
  },
  methods: {
    dateFormat(date) {
      return DateTime.fromJSDate(date)
        .setLocale('fr')
        .toLocaleString(DateTime.DATETIME_SHORT);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-marginless-bottom {
  margin-bottom: 0;
}

/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
.mailto {
  color: $soft-blue;
  &:hover {
    color: $periwinkle-blue;
  }
}
</style>
